//: QUE.CPP -- very simple queue
//. Adapted from "Using C++" 2nd edition, Osborne/McGraw-Hill 1992
//. by Bruce Eckel
#include <iostream.h>

class queue {
  enum { size = 10 };
  int *q[size];
  int in, out; // indexes
public:
  queue() : in(0), out(0) {}
  void add(int * i) {
    q[in++] = i;
    if(in >= size) in = 0;  // wrap
  }
  int* get() {
    if(out == in) return 0;
    int *result = q[out++];
    if(out >= size) out = 0;
    return result;
  }
};

void main() {
  int I[] = { 1, 3, 5, 7, 11, 13 };
  queue iq;
  for(int i = 0; i < sizeof(I)/sizeof(I[0]); i++)
    iq.add(&I[i]);
  for(int* p = iq.get(); p; p = iq.get())
    cout << "iq.get() = " << *p << endl;
}
